<?php
namespace Claromentis\Console\Util;

$GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"] ?: array()) + array("_9810a2810274128200cb24" . "f15909a3f2" => base64_decode("Q2hlY2tpbmcgZG" . "F0YWJhc2UgcGVy" . "bWlzc2lvbnMuLi" . "4="), "_9636e445fbeaa4bbfe5694ed5" . "32de0b1" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbnMgaW5zdWZmaWNpZ" . "W50"), "_4c93d4c40f7ab1" . "a488c387f7f91a6" . "496" => base64_decode("Q2hlY2tpbmc" . "gaW5zdGFsbG" . "F0aW9uLi4u"), "_a70083b91f8d3b0237061e0682" . "6958e8" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc" . "2UgYXZhaWxhYmlsaXR5Li" . "4u"), "_3e09962b663b985bf8c2" . "60ac2e95edc0" => base64_decode("Y29y" . "ZQ=="), "_77713ce236" . "83636d05734" . "08c9a0d0ddb" => base64_decode("RGF0YWJhc2UgcGVyb" . "Wlzc2lvbnMgYXJlIG" . "FkZXF1YXRl"), "_5bcefc1eff68a" . "2aa6ab8f35699a" . "56d08" => base64_decode("RGF0YWJhc2UgaXMgbm90IGF2YWl" . "sYWJsZTog"), "_7b2ca9a105acfcc088d2c15bfe6458" . "b6" => base64_decode("Q29yZSBpcyBub3QgaW5zd" . "GFsbGVk"), "_1094b976516d8df54067d448e66e02" . "97" => base64_decode("RGF0YWJh" . "c2UgaXMg" . "YXZhaWxh" . "Ymxl"));
use Claromentis\Core\Config\Config;
use Claromentis\Core\DAL\DbFactory;
use Claromentis\Core\Module;
use Claromentis\Setup\Exception\NotInstalledException;
use Claromentis\Setup\Task\DatabaseCheck;
use Psr\Log\LoggerAwareInterface;
use Psr\Log\LoggerAwareTrait;
use Psr\Log\NullLogger;
use RuntimeException;




class InstallationChecker implements LoggerAwareInterface
{
    use LoggerAwareTrait;
    protected Config $config;
    protected DbFactory $factory;
    protected Locator $locator;
    protected Module\Api $modules;
    
    
    
    
    
    
    
    
    
    public function __construct(Config $_fd33b1a14db9a1eccfaaa3cb67b5336e, DbFactory $_c8ef295ed962a46e6246480731bf7b99, Locator $_958a49c0e9814c5c29eb8698e3fb6de2, Module\Api $_59eea0afb98cc6c83c49d730362a45fd)
    {
        $this->config = $_fd33b1a14db9a1eccfaaa3cb67b5336e;
        $this->factory = $_c8ef295ed962a46e6246480731bf7b99;
        $this->locator = $_958a49c0e9814c5c29eb8698e3fb6de2;
        $this->modules = $_59eea0afb98cc6c83c49d730362a45fd;
        $this->setLogger(new NullLogger());
    }
    
    
    
    
    
    
    public function isInstalled()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_4c93d4c40f7ab1a488c387f7f91a6" . "496"]);
            $this->verifyInstalled();
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabaseConnection()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_a70083b91f8d3b0237061e06826958" . "e8"]);
            $this->verifyDatabaseConnection();
            $this->logger->debug($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_1094b976516d8df54067d448e66e02" . "97"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_5bcefc1eff68a2aa6ab8f35" . "699a56d08"] . $_c35473364fa7a050299058f332ec29c1->getMessage());
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabasePermissions()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["_9810a281027412" . "8200cb24f15909a" . "3f2"]);
            $this->verifyDatabasePermissions();
            $this->logger->debug($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_77713ce2368" . "3636d0573408" . "c9a0d0ddb"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function verifyInstalled()
    {
        $this->verifyDatabaseConnection();
        $this->verifyDatabasePermissions();
        if (!$this->modules->isInstalled($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_3e09962b663b985bf8c" . "260ac2e95edc0"])) {
            throw new NotInstalledException($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_7b2ca9a105acfcc0" . "88d2c15bfe6458b6"]);
        }
    }
    
    
    
    
    
    
    
    public function verifyDatabaseConnection()
    {
        
        
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        
        
        $this->modules->setDatabase($_4504853ce5094b088c8bdc3d570a0a5d);
    }
    
    
    
    
    
    
    
    public function verifyDatabasePermissions()
    {
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        $_58bc0ced402c33be307fe4d3d5433ed1 = new DatabaseCheck($this->config, $_4504853ce5094b088c8bdc3d570a0a5d);
        $_58bc0ced402c33be307fe4d3d5433ed1->setLogger($this->logger);
        if (!$_58bc0ced402c33be307fe4d3d5433ed1->Check()) {
            foreach ($_58bc0ced402c33be307fe4d3d5433ed1->GetErrors() as $_ba3845cb79c005cf3269af8c83ddbe5e) {
                $this->logger->error($_ba3845cb79c005cf3269af8c83ddbe5e);
            }
            throw new RuntimeException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_9636e445fbeaa" . "4bbfe5694ed532" . "de0b1"]);
        }
    }
    
    
    
    
    
    
    
    protected function getDatabase()
    {
        return $this->factory->GetInstanceFromConfig($this->config);
    }
}